{
  UI Command Manager
  2003-04 -

  2003-11-29 L[Ŏw肷ƈقȂL[Ɖ߂C
  2004-01-25 IDŊU悤ɂ
  2004-01-25 DisableMenu, CheckMenuǉ
  2004-01-25 KeyTable.pas -> SCmd.pasɉ
}

unit SCmd;

interface

uses Windows, SConfFile {,SHash};

const
  IDM_FIRST = 20000; // ID犄U

type
  PCmd = ^TCmd;
  TCmd = record
    Name: string;
    KeyName: string;
    Id: Integer;
  end;

  PCmdTable = ^TCmdTable;
  TCmdTable = array[0..0] of TCmd;

  TMenuItem = record
    Caption: string;
    CmdName: string;
    Enabled: Boolean;
    Checked: Boolean;
  end;

  TSCmd = class(TObject)
  private
    //Hash: TSHash;
    KeyList: array[0..255] of TAccel;
    KeyListCount: Integer;
    CmdTable: PCmdTable;
    CmdTableCount: Integer;
    function StrToAccel(const KeyName: string; const ActionName: string): TAccel;
    function AccelToStr(const Accel: TAccel): string;
    procedure LoadKeymapFromFile(const FileName: string);
    procedure LoadKeymapFromArray(const Keymap: array of string);
    function NameToCmd(const Name: string): PCmd;
    function IdToCmd(Id: Integer): PCmd;
  public
    AccHandle: HACCEL;
    //constructor Create(const ACmdTable: array of TCmd; const DefaultKeys: array of string;
    //  FileName: string; HashTableSize: Integer);
    constructor Create(const ACmdTable: array of TCmd; const DefaultKeys: array of string; FileName: string);
    destructor Destroy; override;
    procedure DisableMenu(var MenuTable: array of TMenuItem; const Names: array of string);
    procedure CheckMenu(var MenuTable: array of TMenuItem; const Name: string; Checked: Boolean);
    procedure GenerateMenu(Menu: HMENU; const MenuTable: array of TMenuItem);
    function Id(const Name: string): Integer;
    function Name(Id: Integer): string;
  end;

procedure StrToKey(const KeyName: string; var Alt, Control, Shift: Boolean; var VKey: UINT);
function GetContextMenuPos(Handle: HWND; LParam: LPARAM; SelPosX, SelPosY: Longint; var pt: TPoint): Boolean;
procedure ResetMenuState(var MenuTable: array of TMenuItem);

implementation

const
  SpKeys: array[0..41] of TCmd = (
    (Name: 'BS';    Id: VK_BACK),
    (Name: 'Tab';   Id: VK_TAB),
    (Name: 'Enter'; Id: VK_RETURN),
    (Name: 'Esc';   Id: VK_ESCAPE),
    (Name: 'Space'; Id: VK_SPACE),
    (Name: 'PgUp';  Id: VK_PRIOR),
    (Name: 'PgDn';  Id: VK_NEXT),
    (Name: 'End';   Id: VK_END),
    (Name: 'Home';  Id: VK_HOME),
    (Name: 'Left';  Id: VK_LEFT),
    (Name: 'Up';    Id: VK_UP),
    (Name: 'Right'; Id: VK_RIGHT),
    (Name: 'Down';  Id: VK_DOWN),
    (Name: 'Ins';   Id: VK_INSERT),
    (Name: 'Del';   Id: VK_DELETE),
    (Name: 'Num0';  Id: VK_NUMPAD0),
    (Name: 'Num1';  Id: VK_NUMPAD1),
    (Name: 'Num2';  Id: VK_NUMPAD2),
    (Name: 'Num3';  Id: VK_NUMPAD3),
    (Name: 'Num4';  Id: VK_NUMPAD4),
    (Name: 'Num5';  Id: VK_NUMPAD5),
    (Name: 'Num6';  Id: VK_NUMPAD6),
    (Name: 'Num7';  Id: VK_NUMPAD7),
    (Name: 'Num8';  Id: VK_NUMPAD8),
    (Name: 'Num9';  Id: VK_NUMPAD9),
    (Name: 'Num*';  Id: VK_MULTIPLY),
    (Name: 'Num+';  Id: VK_ADD),
    (Name: 'Num-';  Id: VK_SUBTRACT),
    (Name: 'Num.';  Id: VK_DECIMAL),
    (Name: 'Num/';  Id: VK_DIVIDE),
    (Name: 'F1';    Id: VK_F1),
    (Name: 'F2';    Id: VK_F2),
    (Name: 'F3';    Id: VK_F3),
    (Name: 'F4';    Id: VK_F4),
    (Name: 'F5';    Id: VK_F5),
    (Name: 'F6';    Id: VK_F6),
    (Name: 'F7';    Id: VK_F7),
    (Name: 'F8';    Id: VK_F8),
    (Name: 'F9';    Id: VK_F9),
    (Name: 'F10';   Id: VK_F10),
    (Name: 'F11';   Id: VK_F11),
    (Name: 'F12';   Id: VK_F12)
  );

procedure StrToKey(const KeyName: string; var Alt, Control, Shift: Boolean; var VKey: UINT);
var
  k, s: string;
  i: Integer;
  p: PChar;
begin
  Alt := False;
  Control := False;
  Shift := False;
  VKey := 0;
  if Length(KeyName) = 1 then
    k := KeyName
  else begin
    s := KeyName;
    i := Pos('-', s);
    if i = 0 then
      k := KeyName
    else begin
      s[i] := #0;
      k := PChar(@s[i+1]);
      p := PChar(s);
      Alt := Pos('A', p) > 0;
      Control := Pos('C', p) > 0;
      Shift := Pos('S', p) > 0;
    end;
  end;

  for i := 0 to High(SpKeys) do
  begin
    if k = SpKeys[i].Name then
    begin
      VKey := SpKeys[i].Id;
      Exit;
    end;
  end;
  VKey := Ord(UpCase(k[1]));
end;

constructor TSCmd.Create(const ACmdTable: array of TCmd; const DefaultKeys: array of string;
  FileName: string);
var
  i: Integer;
  Cmd: PCmd;
begin
  CmdTable := @ACmdTable;
  CmdTableCount := High(ACmdTable) + 1;
  for i := 0 to CmdTableCount - 1 do
    CmdTable[i].Id := i + IDM_FIRST;

  //Hash := TSHash.Create(HashTableSize);
  //for i := 0 to CmdTableCount - 1 do
  //  {$C+} Assert(Hash.Add(CmdTable[i].Name, @CmdTable[i]));

  LoadKeymapFromArray(DefaultKeys);
  LoadKeymapFromFile(FileName);
  AccHandle := CreateAcceleratorTable(KeyList, KeyListCount);

  for i := 0 to KeyListCount - 1 do
  begin
    Cmd := IdToCmd(KeyList[i].cmd);
    if Cmd <> nil then
    begin
      if Cmd.KeyName = '' then
        Cmd.KeyName := AccelToStr(KeyList[i])
      else
        Cmd.KeyName := Cmd.KeyName + ', ' + AccelToStr(KeyList[i]);
    end;
  end;
end;

destructor TSCmd.Destroy;
begin
  //Hash.Free;
  DestroyAcceleratorTable(AccHandle);
  inherited Destroy;
end;

procedure TSCmd.LoadKeymapFromArray(const Keymap: array of string);
var
  i: Integer;
begin
  KeyListCount := (High(Keymap) + 1) div 2;
  for i := 0 to KeyListCount - 1 do
    KeyList[i] := StrToAccel(Keymap[i*2], Keymap[i*2+1]);
end;

procedure TSCmd.LoadKeymapFromFile(const FileName: string);
var
  ConfFile: TSConfFile;
  i: Integer;
begin
  ConfFile := TSConfFile.Create(FileName);
  i := 0;
  while (ConfFile.GetLine) and (i <= High(KeyList)) do
  begin
    KeyList[i] := StrToAccel(ConfFile.Line.Name, ConfFile.Line.Args[0]);
    Inc(i);
  end;
  ConfFile.Free;
  if i > 0 then
    KeyListCount := i;
end;

function TSCmd.StrToAccel(const KeyName: string; const ActionName: string): TAccel;
var
  Alt, Control, Shift: Boolean;
  VKey: UINT;
begin
  Result.cmd := Id(ActionName);
  StrToKey(KeyName, Alt, Control, Shift, VKey);
  Result.key := VKey;
  Result.fVirt := FVIRTKEY;
  if Alt then
    Result.fVirt := Result.fVirt or FALT;
  if Control then
    Result.fVirt := Result.fVirt or FCONTROL;
  if Shift then
    Result.fVirt := Result.fVirt or FSHIFT;
end;

function TSCmd.AccelToStr(const Accel: TAccel): string;
var
  i: Integer;
begin
  Result := '';
  if (Accel.fVirt and FALT) <> 0 then
    Result := 'Alt+';
  if (Accel.fVirt and FSHIFT) <> 0 then
    Result := Result + 'Shift+';
  if (Accel.fVirt and FCONTROL) <> 0 then
    Result := Result + 'Ctrl+';
  for i := 0 to High(SpKeys) do
  begin
    if Accel.key = SpKeys[i].Id then
    begin
      Result := Result + SpKeys[i].Name;
      Exit;
    end;
  end;
  Result := Result + Chr(Accel.key);
end;

procedure TSCmd.DisableMenu(var MenuTable: array of TMenuItem; const Names: array of string);
var
  i, j: Integer;
begin
  for i := 0 to High(MenuTable) do
  begin
    for j := 0 to High(Names) do
      if MenuTable[i].CmdName = Names[j] then
        MenuTable[i].Enabled := False;
  end;
end;

procedure TSCmd.CheckMenu(var MenuTable: array of TMenuItem; const Name: string; Checked: Boolean);
var
  i: Integer;
begin
  for i := 0 to High(MenuTable) do
  begin
    if MenuTable[i].CmdName = Name then
      MenuTable[i].Checked := Checked;
  end;
end;

procedure TSCmd.GenerateMenu(Menu: HMENU; const MenuTable: array of TMenuItem);
var
  i: Integer;
  Cmd: PCmd;
  CurMenu, SubMenu: HMENU;
  State: Integer;
begin
  CurMenu := Menu;
  for i := 0 to High(MenuTable) do
  begin
    with MenuTable[i] do
    begin
      State := 0;
      if not Enabled then
        State := MF_GRAYED;
      if Checked then
        State := State or MF_CHECKED;

      if Caption = '-' then
        AppendMenu(CurMenu, MF_SEPARATOR, 0, nil)
      else if CmdName[1] = '{' then
      begin
        SubMenu := CreatePopupMenu;
        AppendMenu(CurMenu, MF_POPUP or State, SubMenu, PChar(Caption));
        CurMenu := SubMenu;
      end
      else if CmdName = '}' then
        CurMenu := Menu
      else begin
        Cmd := NameToCmd(CmdName);
        if Cmd <> nil then
          with Cmd^ do
            AppendMenu(CurMenu, MF_STRING or State, Id, PChar(Caption+#9+KeyName));
      end;
    end;
  end;
end;

function TSCmd.IdToCmd(Id: Integer): PCmd;
begin
  if (Id < IDM_FIRST) or (Id > IDM_FIRST + CmdTableCount - 1) then
    Result := nil
  else
    Result := @CmdTable[Id-IDM_FIRST];
end;

function TSCmd.NameToCmd(const Name: string): PCmd;
var
  i: Integer;
begin
  Result := nil;
  for i := 0 to CmdTableCount - 1 do
  begin
    if Name = CmdTable[i].Name then
    begin
      Result := @CmdTable[i];
      Break;
    end;
  end;
end;
{
// nbV
begin
  Result := Hash.Get(Name);
end;
}


function TSCmd.Name(Id: Integer): string;
var
  Cmd: PCmd;
begin
  Cmd := IdToCmd(Id);
  if Cmd <> nil then
    Result := Cmd.Name
  else
    Result := '';
end;

function TSCmd.Id(const Name: string): Integer;
var
  Cmd: PCmd;
begin
  Cmd := NameToCmd(Name);
  if Cmd <> nil then
    Result := Cmd.Id
  else
    Result := 0;
end;

function GetContextMenuPos(Handle: HWND; LParam: LPARAM; SelPosX, SelPosY: Longint; var pt: TPoint): Boolean;
var
  rc: TRect;
begin
  if LParam = $FFFFFFFF then
  begin
    pt.x := SelPosX;
    pt.y := SelPosY;
  end else
  begin
    pt.x := LoWord(LParam);
    pt.y := HiWord(LParam);
    ScreenToClient(Handle, pt);
  end;
  GetClientRect(Handle, rc);
  Result := PtInRect(rc, pt);
  ClientToScreen(Handle, pt);
end;

procedure ResetMenuState(var MenuTable: array of TMenuItem);
var
  i: Integer;
begin
  for i := 0 to High(MenuTable) do
  begin
    MenuTable[i].Checked := False;
    MenuTable[i].Enabled := True;
  end;
end;

end.
