{
  2004-01-31 SysUtilsƊ֐Փ˂Ȃ悤ɕύX
             TListDirǉ
  2004-02-01 TSFileǉ
  2004-02-02 Lower, Upperǉ
}

unit SUtil;

interface

uses Windows;

function GetProfDir(const EnvName: string; const Name: string): string;

{ Type Convert Function }

function SStr(Value: Integer): string;
function SZStr(Value, Width: Integer): string; // ̒l͈Ȃ
function SInt(const S: string): Integer;
function Rect(ALeft, ATop, ARight, ABottom: Integer): TRect;
function Point(AX, AY: Integer): TPoint;

{ Strings Function }

function Lower(const S: string): string; // R[hy[Wl(CharLowerBuff APIgp)
function Upper(const S: string): string; // R[hy[Wl(CharUpperBuff APIgp)
//function SPrintf(const Fmt: string; Args: array of const): string;

{ Path Function }

function IsFile(const Path: string): Boolean;
function IsDir(const Path: string): Boolean;
function AbsPath(const Path: string): string;
function BaseName(const Path: string): string;
function DirName(const Path: string): string; // K΃pXɕϊ

{ Misc. }

function CountBits(Value: Integer): Integer;
function NumFormat(Value: Integer): string;
function BytesFormat(Value: Integer): string;
function GetLongFileName(const FileName: string): string;
function GetEnv(const Name: string; const Default: string): string;
function FileTimeToLocalTimeStr(const FileTime: TFileTime): string;
function GetFindData(const Path: string; var FindData: TWin32FindData): Boolean;

{ Classes }

type
  TListDir = class(TObject)
  private
    FHandle: THandle;
    FFindData: TWin32FindData;
    FFileName: string;
    FIsDir: Boolean;
  public
    constructor Create(const Path: string; Mask: string);
    destructor Destroy; override;
    function Next: Boolean;
    property FileName: string read FFileName;
    property IsDir: Boolean read FIsDir;
  end;

  TSFile = class(TObject)
  private
    FFile: File;
    FOpend: Boolean;
    FResultCode: Integer;
    function GetSize: Integer;
  public
    constructor Create(const FileName: string; const Mode: string);
    destructor Destroy; override;
    function Read(var Buffer; Count: Integer): Longint;
    function Write(var Buffer; Count: Integer): Longint;
    property ResultCode: Integer read FResultCode;
    property Size: Integer read GetSize;
  end;

implementation

function GetProfDir(const EnvName: string; const Name: string): string;
var
  s: string;
begin
  Result := '';
  // R}hCŎw肳ꂽꍇ
  s := ParamStr(1);
  if Copy(s, 1, 6) = '/prof=' then
    Result := Copy(s, 7, Length(s)-6);
  // ϐ
  if Result = '' then
  begin
    Result := GetEnv(EnvName, '');
    if Result <> '' then
      Result := Result + '\' + Name;
  end;
  // ftHgexeƓꏊ
  if Result = '' then
    Result := DirName(ParamStr(0));
end;

{ Type Convert Function }

function SStr(Value: Integer): string;
begin
  Str(Value, Result);
end;

function SZStr(Value, Width: Integer): string;
var
  sign: Boolean;
  p: PChar;
begin
  sign := Value < 0;
  if sign then
  begin
    Value := -Value;
    Dec(Width);
  end;
  Str(Value :Width, Result);
  p := @Result[1];
  while p^ = ' ' do
  begin
    p^ := '0';
    Inc(p);
  end;
  if sign then
    Result := '-' + Result;
end;

function SInt(const S: string): Integer;
var
  code: Integer;
begin
  Val(s, Result, code);
end;

function Rect(ALeft, ATop, ARight, ABottom: Integer): TRect;
begin
  with Result do
  begin
    Left := ALeft;
    Top := ATop;
    Right := ARight;
    Bottom := ABottom;
  end;
end;

function Point(AX, AY: Integer): TPoint;
begin
  with Result do
  begin
    X := AX;
    Y := AY;
  end;
end;

{ String Function }

function Lower(const S: string): string;
begin
  Result := Copy(S, 1, Length(S));
  CharLowerBuff(PChar(Result), Length(Result));
end;

function Upper(const S: string): string;
begin
  Result := Copy(S, 1, Length(S));
  CharUpperBuff(PChar(Result), Length(Result));
end;

{
// 储K
function SPrintf(const Fmt: string; Args: array of const): string;
type
  PPointerArray = ^TPointerArray;
  TPointerArray = array[0..0] of Pointer;
var
  p: PPointerArray;
  i, len, maxlen, maxintlen: Integer;
begin
  maxlen := Length(Fmt) + 1;
  maxintlen := Length(SStr(High(Integer)))+2;
  GetMem(p, (High(Args)+1) * SizeOf(Pointer));
  for i := 0 to High(Args) do
  begin
    with Args[i] do
      case VType of
        vtChar:
          begin
            p[i] := Pointer(VChar);
            Inc(maxlen);
          end;
        vtInteger:
          begin
            p[i] := Pointer(VInteger);
            Inc(maxlen, maxintlen);
          end;
        vtAnsiString:
          begin
            p[i] := VAnsiString;
            Inc(maxlen, Length(string(VAnsiString)));
          end;
      end;
  end;
  SetLength(Result, maxlen);
  len := wvsprintf(PChar(Result), PChar(Fmt), Pointer(p));
  SetLength(Result, len);
  FreeMem(p);
end;
}

{ Path Function }

function IsFile(const Path: string): Boolean;
var
  r: DWORD;
begin
  r := GetFileAttributes(PChar(Path));
  Result := (r <> $FFFFFFFF) and ((r and FILE_ATTRIBUTE_DIRECTORY) = 0);
end;

function IsDir(const Path: string): Boolean;
var
  r: DWORD;
begin
  r := GetFileAttributes(PChar(Path));
  Result := (r <> $FFFFFFFF) and ((r and FILE_ATTRIBUTE_DIRECTORY) <> 0);
end;

function AbsPath(const Path: string): string;
var
  buf: array [0..MAX_PATH] of Char;
  p: PChar;
  len: Integer;
begin
  len := GetFullPathName(PChar(Path), SizeOf(buf), buf, p);
  if buf[len-1] = '\' then
    Dec(len); // \폜
  SetString(Result, buf, len);
end;

function BaseName(const Path: string): string;
var
  buf: array [0..MAX_PATH] of Char;
  p: PChar;
begin
  GetFullPathName(PChar(Path), SizeOf(buf), buf, p);
  Result := p;
end;

function DirName(const Path: string): string;
var
  buf: array [0..MAX_PATH] of Char;
  p: PChar;
  len: Integer;
begin
  len := GetFullPathName(PChar(Path), SizeOf(buf), buf, p); // K΃pXɕϊ
  if p = nil then
    p := @buf[len];
  (p-1)^ := #0; // \폜
  Result := buf;
end;

function GetLongFileName(const FileName: string): string;
var
  buf: array [0..MAX_PATH] of Char;
  p: PChar;
  h: THandle;
  FindData: TWin32FindData;
begin
  Result := '';
  if FileName = '' then
    Exit;
  GetFullPathName(PChar(FileName), SizeOf(buf), buf, p);
  while True do begin
    h := FindFirstFile(buf, FindData);
    if h = INVALID_HANDLE_VALUE then begin
      Result := string(buf) + Result;
      Exit;
    end;
    Windows.FindClose(h);
    if buf[Length(buf)-1] = ':' then begin
      Result := string(buf) + Result;
      Exit;
    end;
    // '.' 狤L(@Win95a)??
    if string(FindData.cFileName) = '.' then begin
      Result := string(buf) + Result;
      Exit;
    end;
    Result := '\' + string(FindData.cFileName) + Result;
    GetFullPathName(buf, SizeOf(buf), buf, p);
    if p <> nil then
      if ((p-1)^ = '\') then (p-1)^ := #0
  end;
end;

// 1̃rbg𐔂
function CountBits(Value: Integer): Integer;
begin
  Result := 0;
  repeat
    Inc(Result, Value and 1);
    Value := Value shr 1
  until Value = 0;
end;

function NumFormat(Value: Integer): string;
var
  s: string;
  nf: TNumberFmt;
  buf: array[0..255] of Char;
begin
  nf.NumDigits := 0;
  nf.LeadingZero := 0;
  nf.Grouping := 3;
  nf.lpDecimalSep := '.';
  nf.lpThousandSep := ',';
  nf.NegativeOrder := 1;
  Str(Value, s);
  GetNumberFormat(LOCALE_USER_DEFAULT, 0, PChar(s), @nf, buf, SizeOf(buf));
  Result := buf;
end;

// exploreroCg\L
function BytesFormat(Value: Integer): string;
var
  u, s: string;
begin
  if Value < 1024 then
  begin
    Result := SStr(Value) + ' bytes';
    Exit;
  end;
  if Value >= 1000*1000*1000 then
  begin
    Value := (Value div 1024 div 1024)*100 div 1024;
    u := ' GB';
  end
  else if Value >= 1000*1000 then
  begin
    Value := (Value div 1024)*100 div 1024;
    u := ' MB';
  end
  else if Value >= 1000 then
  begin
    Value := Value*100 div 1024;
    u := ' KB';
  end
  else begin
    Value := Value*100;
    u := ' bytes';
  end;
  Str(Value, s);
  if Value >= 10000 then
    Result := s[1]+s[2]+s[3]
  else if Value >= 1000 then
    Result := s[1]+s[2]+'.'+s[3]
  else if Value >= 100 then
    Result := s[1]+'.'+s[2]+s[3]
  else
    Result := '0.'+s[1]+s[2];
  Result := Result + u;
end;
{
var
  c: Currency;
  u: string;
  a: Integer;
begin
  if Value >= 1024*1024*1024 then begin
    c := Value / 1024 / 1024 / 1024;
    u := ' GB';
  end
  else if Value >= 1024*1024 then begin
    c := Value / 1024 / 1024;
    u := ' MB';
  end
  else if Value >= 1024 then begin
    c := Value / 1024;
    u := ' KB';
  end
  else begin
    c := Value;
    u := ' bytes';
  end;
  if c >= 100 then
    a := 0
  else if c >= 10 then
    a := 1
  else
    a := 2;
  Str(c :0 :a, Result);
  Result := Result + u;
end;
}

function GetEnv(const Name: string; const Default: string): string;
var
  buf: array[0..1023] of Char;
begin
  SetString(Result, Buf, GetEnvironmentVariable(PChar(Name), buf, SizeOf(buf)));
  if Result = '' then
    Result := Default;
end;

// FileTime(UTC) ftHgP[̓𓾂
function FileTimeToLocalTimeStr(const FileTime: TFileTime): string;
var
  buf: array[0..1023] of Char;
  st: TSystemTime;
  ft: TFileTime;
begin
  if (FileTime.dwLowDateTime = 0) and (FileTime.dwHighDateTime = 0) then
  begin
    Result := '';
    Exit;
  end;
  FileTimeToLocalFileTime(FileTime, ft);
  FileTimeToSystemTime(ft, st);
  GetDateFormat(LOCALE_USER_DEFAULT, DATE_LONGDATE, @st, nil, buf, SizeOf(buf));
  Result := buf;
  GetTimeFormat(LOCALE_USER_DEFAULT, 0, @st, nil, buf, SizeOf(buf));
  Result := Result + ' ' + buf;
end;

function GetFindData(const Path: string; var FindData: TWin32FindData): Boolean;
var
  h: THandle;
begin
  FillChar(FindData, SizeOf(FindData), 0);
  h := FindFirstFile(PChar(Path), FindData);
  Result :=  h <> INVALID_HANDLE_VALUE;
  if Result then
    Windows.FindClose(h);
end;

{ TListDir }

constructor TListDir.Create(const Path: string; Mask: string);
begin
  if Mask = '' then
    Mask := '*.*';
  FHandle := FindFirstFile(PChar(Path+'\'+Mask), FFindData);
end;

destructor TListDir.Destroy;
begin
  if FHandle <> INVALID_HANDLE_VALUE then
    Windows.FindClose(FHandle);
  inherited;
end;

function TListDir.Next: Boolean;
begin
  if FHandle = INVALID_HANDLE_VALUE then
  begin
    Result := False;
    Exit;
  end;
  Result := FindNextFile(FHandle, FFindData);
  if Result then
  begin
    FFileName := FFindData.cFileName;
    FIsDir := (FFindData.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) <> 0
  end;
end;

{ TSFile }

constructor TSFile.Create(const FileName: string; const Mode: string);
begin
  FileMode := 0; // read only mode
  AssignFile(FFile, FileName);
  {$I-}
  if Mode = 'w' then
    Rewrite(FFile, 1)
  else
    Reset(FFile, 1);
  {$I+}
  FResultCode := IOResult;
  FOpend := FResultCode = 0;
end;

destructor TSFile.Destroy;
begin
  if FOpend then
    CloseFile(FFile);
  inherited;
end;

function TSFile.GetSize: Integer;
begin
  Result := FileSize(FFile);
end;

function TSFile.Read(var Buffer; Count: Integer): Longint;
begin
  {$I-}
  BlockRead(FFile, Buffer, Count, Result);
  {$I+}
  FResultCode := IOResult;
end;

function TSFile.Write(var Buffer; Count: Integer): Longint;
begin
  {$I-}
  BlockWrite(FFile, Buffer, Count, Result);
  {$I+}
  FResultCode := IOResult;
end;

end.

